%define __distdep %(rpm -qf /etc/redhat-release | sed 's/-[^-]*$//' | head -1)
%define __distpkg %(echo %{__distdep} | sed 's/-[^-]*$//')
%define __distvers %(echo %{__distdep} | sed 's/.*-//' | tr -d '[:alpha:]')
%define __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' /etc/redhat-release | tr -d '[:space:]' | cut -c 1-4 | tr '[:upper:]' '[:lower:]')
%define __perl_version %(eval "`perl -V:version`"; echo $version)
%define __perl_package WeakRef

Summary:	%{__perl_package} module for perl 
Name:		perl-%{__perl_package}
Version:	0.01
Release:	3.%{__distinit}%{__distvers}
License:	GPL or Artistic
Group:		Applications/CPAN
Source0:	%{__perl_package}-%{version}.tar.gz
Url:		http://www.cpan.org
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Requires:	%{__distpkg} >= %{__distvers}, perl >= %{__perl_version}

%description
A patch to Perl 5.005_55 by the author implements a core API for weak
references. This module is a Perl-level interface to that API, allowing
weak references to be created in Perl.

A weak reference is just like an ordinary Perl reference except that
it isn't included in the reference count of the thing referred to.
This means that once all references to a particular piece of data are
weak, the piece of data is freed and all the weak references are set
to undef. This is particularly useful for implementing circular
data structures without memory leaks or caches of objects.

%prep
%setup -q -n %{__perl_package}-%{version}

%build
CFLAGS="$RPM_OPT_FLAGS" %{__perl} Makefile.PL PREFIX=$RPM_BUILD_ROOT%{_prefix} INSTALLDIRS=vendor
%{__make}
%{__make} test

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%install
%{__rm} -rf $RPM_BUILD_ROOT
%makeinstall

[ -x /usr/lib/rpm/brp-compress ] && /usr/lib/rpm/brp-compress

find $RPM_BUILD_ROOT \( -name perllocal.pod -o -name .packlist \) -exec %{__rm} -v {} \;

find $RPM_BUILD_ROOT%{_prefix} -type f -print | \
    %{__sed} "s@^$RPM_BUILD_ROOT@@g" | \
    grep -v perllocal.pod | \
    grep -v "\.packlist" > %{__perl_package}-%{version}-filelist
if [ "$(%{__cat} %{__perl_package}-%{version}-filelist)X" = "X" ] ; then
    echo "ERROR: EMPTY FILE LIST"
    exit -1
fi

%files -f %{__perl_package}-%{version}-filelist
%defattr(-,root,root)
%doc README* MANIFEST Changes

%changelog
* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 0.01-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 0.01-2
- Unified spec file for Red Hat and Fedora Core.

* Tue Feb 10 2004 Paul Howarth <paul@city-fan.org> 0.01-1.fc1
- Initial build
